function output = figtest(a)
clc
buildlayout



function buildlayout
mh = myfigure(800,600);
data = {{'Dialog',[];'File',[]}};
set(mh,'UserData',data);
mytabs(mh,8);


%=========================================================================%
%switch tab
function tabswitch(obj,event,mh,n,tab,controls,content)
constr = str2num(get(controls(1),'String'));
if get(obj,'Tag')=='next'
    if nexttab(mh,content{constr},constr)==1
        if constr<n
            set(controls(1),'String',num2str(constr+1));
        end
        if constr==1
            set(controls(3),'Visible','on');
            set(controls(2),'String','Next');
        end
        if constr==n-1
            set(controls(2),'String','Solve');
        end
        if constr < n
            set(tab(constr),'Enable','off');
            hidetab(constr,content);
            set(tab(constr+1),'Enable','Inactive');
            showtab(constr+1,content);
        end
    end
end

if get(obj,'Tag')=='prev'
    if prevtab(mh,content{constr},constr)==1
        if constr > 1
            set(controls(1),'String',num2str(constr-1));
        end
        if constr < n+1
            set(controls(2),'String','Next');
        end
        if constr==2
            set(controls(3),'Visible','off');
        end
        if constr > 0
            set(tab(constr),'Enable','off');
            hidetab(constr,content);
            set(tab(constr-1),'Enable','Inactive');
            showtab(constr-1,content);
        end
    end
end
%=========================================================================%

%=========================================================================%
%unhide tab
function showtab(constr,content)
handles = content{constr};
set(handles,'Visible','on');
%=========================================================================%

%=========================================================================%
%hide tab
function hidetab(constr,content)
handles = content{constr};
set(handles,'Visible','off');
%=========================================================================%

%=========================================================================%
%creates figure with settings and return handle
function mytabs(mh,n)
%!!! n > 1 !!!%
tab = []; %variable with tab handles
hs = get(mh,'Position'); %get figure proportions
const = ceil(hs(3)/n); % generate constant width for each tab

%display tabs
i=1;tab = [tab myuicontrol(mh,'togglebutton',sprintf('tab%d',i),(const*(i-1)),0,const,25,sprintf('Step %d',i),'inactive','on',8)];
for i=2:1:n
    tab = [tab myuicontrol(mh,'togglebutton',sprintf('tab%d',i),(const*(i-1)),0,const,25,sprintf('Step %d',i),'off','on',8)];
end

set(tab,'BackgroundColor',[0.8 0.8 0.8]);
set(tab,'ForegroundColor',[0.2 0.2 0.2]);
set(tab,'FontWeight','bold');


%controls drawing
controls = [];
controls = [controls myuicontrol(mh,'text','tagnumber',0,300,50,50,'1','off','off',8)];
controls = [controls myuicontrol(mh,'pushbutton','next',725,550,50,25,'Next','on','on',8)];
controls = [controls myuicontrol(mh,'pushbutton','prev',675,550,50,25,'Prev','on','off',8)];
controls = [controls myuicontrol(mh,'pushbutton','help',625,550,50,25,'Help','on','on',8)];

%draw each tab (hidden)
for j=1:1:n
    content{j} = eval(sprintf('tablayout(mh,%d)',j));
end
showtab(1,content);
% set tabs controls
set(controls(2),'Callback',{@tabswitch,mh,n,tab,controls,content});
set(controls(3),'Callback',{@tabswitch,mh,n,tab,controls,content});
%=========================================================================%

%=========================================================================%
%creates figure with settings and return handle
function handle = myfigure(w,h)
fig.Name = 'Dynopt GUI';
fig.MenuBar = 'none';
fig.Position = retPosition(w,h);
fig.WindowStyle = 'normal';
fig.Units = 'pixels';
fig.Color = [1 1 1];
fig.NumberTitle = 'off';
fig.Resize = 'off';
handle = eval(sprintf('figure(%s);',struct2str(fig)));
%=========================================================================%

%=========================================================================%
%creates uicontrol with settings and return handle
function handle = myuicontrol(handle,style,tag,left,top,width,height,string,enable,visible,textsize)
ui.Units = 'pixels';
ui.Style = style;
ui.Tag = tag;
ui.Enable = enable;
ui.Visible = visible;
ui.String = string;
hs = get(handle,'Position');
ui.Position = [left, hs(4)-(top+height), width, height];
ui.FontName = 'Verdana';
ui.FontSize = textsize;
ui.FontUnits = 'pixels';
ui.HorizontalAlignment = 'left';
handle = eval(sprintf('uicontrol(%d,%s);',handle,struct2str(ui)));
%=========================================================================%

%=========================================================================%
% tab layout
function ret = tablayout(mh,tn)
switch tn
%=========================================================================%    
    case 1
%=========================================================================%
%================================TAB1=====================================%
        topic={
                'optimisation problem'
                'parameter estimation problem'
                'optimisation or parameter estimation problem'
                'Create new dynamic non-linear'
                'Load and edit old dynamic non-linear'
                };
        ret(1) = [myuicontrol(mh,'radiobutton','tab1radio1',200,150,300,25,topic{1},'on','off',11)];
        ret(2) = [myuicontrol(mh,'radiobutton','tab1radio2',200,200,300,25,topic{2},'on','off',11)];
        ret(3) = [myuicontrol(mh,'radiobutton','tab1radio3',200,350,400,25,topic{3},'on','off',11)];
        set(ret(1:3),'Callback',{@radioswitch,ret(1:3)});
        set(ret(1:3),'BackgroundColor',[1 1 1]);
        set(ret(1:3),'ForegroundColor',[0.5 0.5 0.4]);
        set(ret(1),'Value',1);
        set(ret(1),'UserData',1);
        
        ret(4) = [myuicontrol(mh,'text','tab1text1',75,100,550,30,topic{4},'on','off',16)];
        ret(5) = [myuicontrol(mh,'text','tab1text2',75,300,550,30,topic{5},'on','off',16)];
        set(ret(4:5),'BackgroundColor',[1 1 1]);
        set(ret(4:5),'ForegroundColor',[0.5 0.6 0.7]);
%=========================================================================%
    case 2
%=========================================================================%
%================================TAB2=====================================%
        text = {
                'NLP Solver settings'
                'Optimisation settings'
                'Display'
                'Maximal number of function evaluations'
                'Maximal number of iterarions'
                'Tolerance for objective function'
                'Tolerance for constraints'
                'Tolerance for variables'
                'optimise times'
                'optimise controls'
                'optimise times and controls'
                'optimise parameters'
                'optimise times and parameters'
                'optimise controls and parameters'
                'optimise all: times, controls, parameters'
                'Iterations'
                'Nothing'
                };
        ret(01) = [myuicontrol(mh,'text','tab2text1',50,60,250,35,text{1},'on','off',16)];
        ret(02) = [myuicontrol(mh,'text','tab2text2',50,280,250,35,text{2},'on','off',16)];
        ret(03) = [myuicontrol(mh,'text','tab2text3',150,100,250,20,text{3},'on','off',10)];
        ret(04) = [myuicontrol(mh,'text','tab2text4',150,125,350,20,text{4},'on','off',10)];
        ret(05) = [myuicontrol(mh,'text','tab2text5',150,150,250,20,text{5},'on','off',10)];
        ret(06) = [myuicontrol(mh,'text','tab2text6',150,175,250,20,text{6},'on','off',10)];
        ret(07) = [myuicontrol(mh,'text','tab2text7',150,200,250,20,text{7},'on','off',10)];
        ret(08) = [myuicontrol(mh,'text','tab2text8',150,225,250,20,text{8},'on','off',10)];
        ret(09) = [myuicontrol(mh,'radiobutton','tab2radio1',150,320,350,20,text{9},'on','off',10)];
        ret(10) = [myuicontrol(mh,'radiobutton','tab2radio2',150,345,350,20,text{10},'on','off',10)];
        ret(11) = [myuicontrol(mh,'radiobutton','tab2radio3',150,370,350,20,text{11},'on','off',10)];
        ret(12) = [myuicontrol(mh,'radiobutton','tab2radio4',150,395,350,20,text{12},'on','off',10)];
        ret(13) = [myuicontrol(mh,'radiobutton','tab2radio5',150,420,350,20,text{13},'on','off',10)];
        ret(14) = [myuicontrol(mh,'radiobutton','tab2radio6',150,445,350,20,text{14},'on','off',10)];
        ret(15) = [myuicontrol(mh,'radiobutton','tab2radio7',150,470,350,20,text{15},'on','off',10)];
        ret(16) = [myuicontrol(mh,'radiobutton','tab2radio8',450,100,100,20,text{16},'on','off',10)];
        ret(17) = [myuicontrol(mh,'radiobutton','tab2radio9',550,100,100,20,text{17},'on','off',10)];
        ret(18) = [myuicontrol(mh,'edit','tab2edit1',450,125,65,20,'1e5','on','off',10)];
        ret(19) = [myuicontrol(mh,'edit','tab2edit2',450,150,65,20,'1e5','on','off',10)];
        ret(20) = [myuicontrol(mh,'edit','tab2edit3',450,175,65,20,'1e-7','on','off',10)];
        ret(21) = [myuicontrol(mh,'edit','tab2edit4',450,200,65,20,'1e-7','on','off',10)];
        ret(22) = [myuicontrol(mh,'edit','tab2edit5',450,225,65,20,'1e-7','on','off',10)];
        ret(23) = [myuicontrol(mh,'pushbutton','tab2btn01',520,125,20,20,'+','on','off',8)];
        ret(24) = [myuicontrol(mh,'pushbutton','tab2btn02',540,125,20,20,'-','on','off',8)];
        ret(25) = [myuicontrol(mh,'pushbutton','tab2btn03',560,125,20,20,'e+','on','off',8)];
        ret(26) = [myuicontrol(mh,'pushbutton','tab2btn04',580,125,20,20,'e-','on','off',8)];
        ret(27) = [myuicontrol(mh,'pushbutton','tab2btn05',520,150,20,20,'+','on','off',8)];
        ret(28) = [myuicontrol(mh,'pushbutton','tab2btn06',540,150,20,20,'-','on','off',8)];
        ret(29) = [myuicontrol(mh,'pushbutton','tab2btn07',560,150,20,20,'e+','on','off',8)];
        ret(30) = [myuicontrol(mh,'pushbutton','tab2btn08',580,150,20,20,'e-','on','off',8)];
        ret(31) = [myuicontrol(mh,'pushbutton','tab2btn09',520,175,20,20,'+','on','off',8)];
        ret(32) = [myuicontrol(mh,'pushbutton','tab2btn10',540,175,20,20,'-','on','off',8)];
        ret(33) = [myuicontrol(mh,'pushbutton','tab2btn11',560,175,20,20,'e+','on','off',8)];
        ret(34) = [myuicontrol(mh,'pushbutton','tab2btn12',580,175,20,20,'e-','on','off',8)];
        ret(35) = [myuicontrol(mh,'pushbutton','tab2btn13',520,200,20,20,'+','on','off',8)];
        ret(36) = [myuicontrol(mh,'pushbutton','tab2btn14',540,200,20,20,'-','on','off',8)];
        ret(37) = [myuicontrol(mh,'pushbutton','tab2btn15',560,200,20,20,'e+','on','off',8)];
        ret(38) = [myuicontrol(mh,'pushbutton','tab2btn16',580,200,20,20,'e-','on','off',8)];
        ret(39) = [myuicontrol(mh,'pushbutton','tab2btn17',520,225,20,20,'+','on','off',8)];
        ret(40) = [myuicontrol(mh,'pushbutton','tab2btn18',540,225,20,20,'-','on','off',8)];
        ret(41) = [myuicontrol(mh,'pushbutton','tab2btn19',560,225,20,20,'e+','on','off',8)];
        ret(42) = [myuicontrol(mh,'pushbutton','tab2btn20',580,225,20,20,'e-','on','off',8)];

        set(ret(1:2),'BackgroundColor',[1 1 1]);
        set(ret(1:2),'ForegroundColor',[0.5 0.6 0.7]);        
        set(ret(18:22),'Enable','Inactive');
        set(ret(3:22),'BackgroundColor',[1 1 1]);
        set(ret(3:22),'ForegroundColor',[0.5 0.5 0.4]);
        set(ret(23:42),'Callback',{@incrementit,ret(18:22)});
%=========================================================================%
    case 3
%=========================================================================%
%================================TAB3=====================================%
        text = {
                'Initials and boundries'
                'Number of states'
                'Number of controls'
                'Number of parameters'
                'Number of collocation points for states'
                'Number of collocation points for controls'
                'Interval widths'
                'Bounds for states'
                'Bounds for controls'
                'Bounds for parameters'
                'Multistart'
                'Final time'
                'Path to experimental data'
                };
        ret(01) = [myuicontrol(mh,'text','tab3text1',50,60,250,35,text{1},'on','off',16)];
        ret(02) = [myuicontrol(mh,'text','tab3text2',100,100,350,20,text{2},'on','off',10)];
        ret(03) = [myuicontrol(mh,'text','tab3text3',100,125,350,20,text{3},'on','off',10)];
        ret(04) = [myuicontrol(mh,'text','tab3text4',100,150,350,20,text{4},'on','off',10)];
        ret(05) = [myuicontrol(mh,'text','tab3text5',100,175,350,20,text{5},'on','off',10)];
        ret(06) = [myuicontrol(mh,'text','tab3text6',100,200,350,20,text{6},'on','off',10)];
        ret(07) = [myuicontrol(mh,'text','tab3text7',100,225,350,20,text{7},'on','off',10)];
        ret(08) = [myuicontrol(mh,'text','tab3text8',100,250,350,20,text{8},'on','off',10)];
        ret(09) = [myuicontrol(mh,'text','tab3text9',100,275,350,20,text{9},'on','off',10)];
        ret(10) = [myuicontrol(mh,'text','tab3text10',100,300,350,20,text{10},'on','off',10)];
        ret(11) = [myuicontrol(mh,'text','tab3text11',100,325,350,20,text{11},'on','off',10)];
        ret(12) = [myuicontrol(mh,'text','tab3text12',100,350,350,20,text{12},'on','off',10)];
        ret(13) = [myuicontrol(mh,'text','tab3text13',100,375,350,20,text{13},'on','off',10)];
        ret(14) = [myuicontrol(mh,'edit','tab3edittext1',450,100,250,20,[],'on','off',8)];
        ret(15) = [myuicontrol(mh,'edit','tab3edittext2',450,125,250,20,[],'on','off',8)];
        ret(16) = [myuicontrol(mh,'edit','tab3edittext3',450,150,250,20,[],'on','off',8)];
        ret(17) = [myuicontrol(mh,'edit','tab3edittext4',450,175,250,20,[],'on','off',8)];
        ret(18) = [myuicontrol(mh,'edit','tab3edittext5',450,200,250,20,[],'on','off',8)];
        ret(19) = [myuicontrol(mh,'edit','tab3edittext6',450,225,250,20,[],'on','off',8)];
        ret(20) = [myuicontrol(mh,'edit','tab3edittext7',450,250,250,20,[],'on','off',8)];
        ret(21) = [myuicontrol(mh,'edit','tab3edittext8',450,275,250,20,[],'on','off',8)];
        ret(22) = [myuicontrol(mh,'edit','tab3edittext9',450,300,250,20,[],'on','off',8)];
        ret(23) = [myuicontrol(mh,'edit','tab3edittext10',450,325,250,20,[],'on','off',8)];
        ret(24) = [myuicontrol(mh,'edit','tab3edittext11',450,350,250,20,[],'on','off',8)];
        ret(25) = [myuicontrol(mh,'edit','tab3edittext12',450,375,250,20,[],'on','off',8)];
        ret(26) = [myuicontrol(mh,'pushbutton','tab3browsepath1',705,375,50,20,'Browse','on','off',8)];
        
        set(ret(1),'BackgroundColor',[1 1 1]);
        set(ret(1),'ForegroundColor',[0.5 0.6 0.7]);
        set(ret(2:24),'BackgroundColor',[1 1 1]);
        set(ret(2:24),'ForegroundColor',[0.5 0.5 0.4]); 
        set(ret(26),'Callback',{@loadparamdata,[ret(25)]});
%=========================================================================%
    case 4
%=========================================================================%
%================================TAB4=====================================%
        ret(01) = [myuicontrol(mh,'text','tab4text1',15,50,200,30,'Objective function','on','off',14)];
        ret(02) = [myuicontrol(mh,'listbox','tab4list1',30,85,635,18,[],'on','off',8)];
        ret(03) = [myuicontrol(mh,'pushbutton','tab4edit1',675,80,50,25,'Edit','on','off',8)];
        ret(04) = [myuicontrol(mh,'pushbutton','tab4clear1',725,80,50,25,'Clear','on','off',8)];
        ret(05) = [myuicontrol(mh,'text','tab4text2',15,120,200,30,'Process','on','off',14)];
        ret(06) = [myuicontrol(mh,'text','tab4text3',30,340,300,25,'ODE or DAE process description','on','off',11)]; 
        ret(07) = [myuicontrol(mh,'listbox','tab4list3',30,360,635,180,[],'on','off',8)];        
        ret(08) = [myuicontrol(mh,'pushbutton','tab4add3',675,430,50,25,'Add','on','off',8)];        
        ret(09) = [myuicontrol(mh,'pushbutton','tab4edit3',725,430,50,25,'Edit','on','off',8)];        
        ret(10) = [myuicontrol(mh,'pushbutton','tab4clear3',675,455,50,25,'Clear','on','off',8)];                
        ret(11) = [myuicontrol(mh,'pushbutton','tab4clearall3',725,455,50,25,'Clear all','on','off',8)];                        
        ret(12) = [myuicontrol(mh,'pushbutton','tab4up3',700,405,50,25,'Up','on','off',8)];                
        ret(13) = [myuicontrol(mh,'pushbutton','tab4down3',700,480,50,25,'Down','on','off',8)];
        ret(14) = [myuicontrol(mh,'text','tab4text5',30,150,300,20,'Initial conditions for states','on','off',10)]; 
        ret(15) = [myuicontrol(mh,'text','tab4text6',30,190,300,20,'Initial conditions for parameters','on','off',10)]; 
        ret(16) = [myuicontrol(mh,'text','tab4text7',30,230,300,20,'Mass matrix','on','off',10)]; 
        ret(17) = [myuicontrol(mh,'text','tab4text8',30,270,300,20,'Initial control values for each interval','on','off',10)]; 
        ret(18) = [myuicontrol(mh,'edit','tab4edittext1',50,170,300,20,'','on','off',8)]; 
        ret(19) = [myuicontrol(mh,'edit','tab4edittext2',50,210,300,20,'','on','off',8)]; 
        ret(20) = [myuicontrol(mh,'edit','tab4edittext3',50,250,300,20,'','on','off',8)];
        ret(21) = [myuicontrol(mh,'edit','tab4edittext4',50,290,300,20,'','on','off',8)];
        
        set([ret(1) ret(5:6)],'BackgroundColor',[1 1 1]);
        set([ret(1) ret(5:6)],'ForegroundColor',[0.5 0.6 0.7]);
        set([ret(2) ret(7) ret(14:21)],'BackgroundColor',[1 1 1]);
        set([ret(7)],'ForegroundColor',[0.1 0.1 0.1]);
        set(ret(14:21),'ForegroundColor',[0.5 0.5 0.4]);
        handles =[ret(2) 0 ret(7)]; %handles are indexed by number from Tag last char
        inputdata{1}{1} = 'Enter objective function';
        inputdata{1}{2} = 'Objective function input';
        inputdata{2}{1} = [];
        inputdata{2}{2} = [];
        inputdata{3}{1} = 'Enter process equation';
        inputdata{3}{2} = 'Process equations input';
        set([ret(3:4) ret(8:13)],'Callback',{@tab2buttons,handles,inputdata});
%=========================================================================%
    case 5
%=========================================================================%
%================================TAB5=====================================%
        ret(01) = [myuicontrol(mh,'text','tab5text1',15,50,500,30,'Constraints applied at initial time t0:','on','off',14)];
        ret(02) = [myuicontrol(mh,'text','tab5text2',45,80,200,22,'equality constraints','on','off',11)];
        ret(03) = [myuicontrol(mh,'text','tab5text2',45,320,200,22,'inequality constraints','on','off',11)];
        ret(04) = [myuicontrol(mh,'listbox','tab5list1',30,100,635,200,[],'on','off',8)];
        ret(05) = [myuicontrol(mh,'listbox','tab5list2',30,340,635,200,[],'on','off',8)];        
        ret(06) = [myuicontrol(mh,'pushbutton','tab5add2',675,175,50,25,'Add','on','off',8)];        
        ret(07) = [myuicontrol(mh,'pushbutton','tab5edit2',725,175,50,25,'Edit','on','off',8)];        
        ret(08) = [myuicontrol(mh,'pushbutton','tab5clear2',675,200,50,25,'Clear','on','off',8)];                
        ret(09) = [myuicontrol(mh,'pushbutton','tab5clearall2',725,200,50,25,'Clear all','on','off',8)];                        
        ret(10) = [myuicontrol(mh,'pushbutton','tab5up2',700,150,50,25,'Up','on','off',8)];                
        ret(11) = [myuicontrol(mh,'pushbutton','tab5down2',700,225,50,25,'Down','on','off',8)];                        
        ret(12) = [myuicontrol(mh,'pushbutton','tab5add3',675,420,50,25,'Add','on','off',8)];        
        ret(13) = [myuicontrol(mh,'pushbutton','tab5edit3',725,420,50,25,'Edit','on','off',8)];        
        ret(14) = [myuicontrol(mh,'pushbutton','tab5clear3',675,445,50,25,'Clear','on','off',8)];                
        ret(15) = [myuicontrol(mh,'pushbutton','tab5clearall3',725,445,50,25,'Clear all','on','off',8)];                        
        ret(16) = [myuicontrol(mh,'pushbutton','tab5up3',700,395,50,25,'Up','on','off',8)];                
        ret(17) = [myuicontrol(mh,'pushbutton','tab5down3',700,470,50,25,'Down','on','off',8)];                        
        set(ret(1:3),'BackgroundColor',[1 1 1]);
        set(ret(1:3),'ForegroundColor',[0.5 0.6 0.7]);
        set(ret(4:5),'BackgroundColor',[1 1 1]);
        set(ret(4:5),'ForegroundColor',[0.1 0.1 0.1]);
        handles =[0 ret(4) ret(5)];
        inputdata{1}{1} = [];
        inputdata{1}{2} = [];
        inputdata{2}{1} = 'Add equality constraint';
        inputdata{2}{2} = 'equality constraint input';
        inputdata{3}{1} = 'Add inequality constraint';
        inputdata{3}{2} = 'Inequality constraint input';
        set(ret(6:17),'Callback',{@tab2buttons,handles,inputdata});
%=========================================================================%
    case 6
%=========================================================================%
%================================TAB6=====================================%
        ret(01) = [myuicontrol(mh,'text','tab6text1',15,50,800,30,'Constraints applied at whole time interval between initial t0 and final tf time:','on','off',14)];
        ret(02) = [myuicontrol(mh,'text','tab6text2',45,80,200,22,'equality constraints','on','off',11)];
        ret(03) = [myuicontrol(mh,'text','tab6text2',45,320,200,22,'inequality constraints','on','off',11)];
        ret(04) = [myuicontrol(mh,'listbox','tab6list1',30,100,635,200,[],'on','off',8)];
        ret(05) = [myuicontrol(mh,'listbox','tab6list2',30,340,635,200,[],'on','off',8)];        
        ret(06) = [myuicontrol(mh,'pushbutton','tab6add2',675,175,50,25,'Add','on','off',8)];        
        ret(07) = [myuicontrol(mh,'pushbutton','tab6edit2',725,175,50,25,'Edit','on','off',8)];        
        ret(08) = [myuicontrol(mh,'pushbutton','tab6clear2',675,200,50,25,'Clear','on','off',8)];                
        ret(09) = [myuicontrol(mh,'pushbutton','tab6clearall2',725,200,50,25,'Clear all','on','off',8)];                        
        ret(10) = [myuicontrol(mh,'pushbutton','tab6up2',700,150,50,25,'Up','on','off',8)];                
        ret(11) = [myuicontrol(mh,'pushbutton','tab6down2',700,225,50,25,'Down','on','off',8)];                        
        ret(12) = [myuicontrol(mh,'pushbutton','tab6add3',675,420,50,25,'Add','on','off',8)];        
        ret(13) = [myuicontrol(mh,'pushbutton','tab6edit3',725,420,50,25,'Edit','on','off',8)];        
        ret(14) = [myuicontrol(mh,'pushbutton','tab6clear3',675,445,50,25,'Clear','on','off',8)];                
        ret(15) = [myuicontrol(mh,'pushbutton','tab6clearall3',725,445,50,25,'Clear all','on','off',8)];                        
        ret(16) = [myuicontrol(mh,'pushbutton','tab6up3',700,395,50,25,'Up','on','off',8)];                
        ret(17) = [myuicontrol(mh,'pushbutton','tab6down3',700,470,50,25,'Down','on','off',8)];                        
        set(ret(1:3),'BackgroundColor',[1 1 1]);
        set(ret(1:3),'ForegroundColor',[0.5 0.6 0.7]);
        set(ret(4:5),'BackgroundColor',[1 1 1]);
        set(ret(4:5),'ForegroundColor',[0.1 0.1 0.1]);        
        handles = [0 ret(4) ret(5)];
        inputdata{1}{1} = [];
        inputdata{1}{2} = [];
        inputdata{2}{1} = 'Add equality constraint';
        inputdata{2}{2} = 'equality constraint input';
        inputdata{3}{1} = 'Add inequality constraint';
        inputdata{3}{2} = 'Inequality constraint input';
        set(ret(6:17),'Callback',{@tab2buttons,handles,inputdata});
%=========================================================================%
    case 7
%=========================================================================%
%================================TAB7=====================================%
        ret(01) = [myuicontrol(mh,'text','tab7text1',15,50,500,30,'Constraints applied at final time tf:','on','off',14)];
        ret(02) = [myuicontrol(mh,'text','tab7text2',45,80,200,22,'equality constraints','on','off',11)];
        ret(03) = [myuicontrol(mh,'text','tab7text2',45,320,200,22,'inequality constraints','on','off',11)];
        ret(04) = [myuicontrol(mh,'listbox','tab7list1',30,100,635,200,[],'on','off',8)];
        ret(05) = [myuicontrol(mh,'listbox','tab7list2',30,340,635,200,[],'on','off',8)];        
        ret(06) = [myuicontrol(mh,'pushbutton','tab7add2',675,175,50,25,'Add','on','off',8)];        
        ret(07) = [myuicontrol(mh,'pushbutton','tab7edit2',725,175,50,25,'Edit','on','off',8)];        
        ret(08) = [myuicontrol(mh,'pushbutton','tab7clear2',675,200,50,25,'Clear','on','off',8)];                
        ret(09) = [myuicontrol(mh,'pushbutton','tab7clearall2',725,200,50,25,'Clear all','on','off',8)];                        
        ret(10) = [myuicontrol(mh,'pushbutton','tab7up2',700,150,50,25,'Up','on','off',8)];                
        ret(11) = [myuicontrol(mh,'pushbutton','tab7down2',700,225,50,25,'Down','on','off',8)];                        
        ret(12) = [myuicontrol(mh,'pushbutton','tab7add3',675,420,50,25,'Add','on','off',8)];        
        ret(13) = [myuicontrol(mh,'pushbutton','tab7edit3',725,420,50,25,'Edit','on','off',8)];        
        ret(14) = [myuicontrol(mh,'pushbutton','tab7clear3',675,445,50,25,'Clear','on','off',8)];                
        ret(15) = [myuicontrol(mh,'pushbutton','tab7clearall3',725,445,50,25,'Clear all','on','off',8)];                        
        ret(16) = [myuicontrol(mh,'pushbutton','tab7up3',700,395,50,25,'Up','on','off',8)];                
        ret(17) = [myuicontrol(mh,'pushbutton','tab7down3',700,470,50,25,'Down','on','off',8)];                        
        set(ret(1:3),'BackgroundColor',[1 1 1]);
        set(ret(1:3),'ForegroundColor',[0.5 0.6 0.7]);
        set(ret(4:5),'BackgroundColor',[1 1 1]);
        set(ret(4:5),'ForegroundColor',[0.1 0.1 0.1]);        
        handles =[0 ret(4) ret(5)];
        inputdata{1}{1} = [];
        inputdata{1}{2} = [];
        inputdata{2}{1} = 'Add equality constraint';
        inputdata{2}{2} = 'equality constraint input';
        inputdata{3}{1} = 'Add inequality constraint';
        inputdata{3}{2} = 'Inequality constraint input';
        set(ret(6:17),'Callback',{@tab2buttons,handles,inputdata});
%=========================================================================%
    case 8
%=========================================================================%
%================================TAB8=====================================%
        ret(01) = [myuicontrol(mh,'text','tab8text1',270,280,400,60,'Please, press "Solve" button','on','off',14)];
        ret(02) = [myuicontrol(mh,'text','tab8text2',220,300,400,60,'to proceed previously defined problem.','on','off',14)];
        ret(03) = [myuicontrol(mh,'pushbutton','tab8btn1',300,200,200,20,'Save problem','on','off',10)];
        set(ret(1:2),'BackgroundColor',[1 1 1]);
        set(ret(1:2),'ForegroundColor',[0.5 0.6 0.7]);
        set(ret(3),'Callback',{@saveproblem});
%=========================================================================%
end
%=========================================================================%

%=========================================================================%
%save neccessary data
function saveproblem(obj,event)
[filename, pathname] = uiputfile({'*.dop','Dynopt Files';},'Save a dynopt file');
if isequal(filename,0)|isequal(pathname,0)
    warndlg('Inputs were not be saved.');
else
	soutput{1} = get(findobj('Tag','tab2radio8'),'UserData'); % display: iter or off
	soutput{2} = get(findobj('Tag','tab2edit1'),'String'); % MaxFunEvals
	soutput{3} = get(findobj('Tag','tab2edit2'),'String'); % MaxIter
	soutput{4} = get(findobj('Tag','tab2edit3'),'String'); % TolFun
	soutput{5} = get(findobj('Tag','tab2edit4'),'String'); % TolCon
	soutput{6} = get(findobj('Tag','tab2edit5'),'String'); % TolX
	
    soutput{7} = get(findobj('Tag','tab1radio1'),'UserData');%  optvar
	soutput{8} = get(findobj('Tag','tab2radio1'),'UserData');%  optvar
	soutput{9} = get(findobj('Tag','tab2radio4'),'UserData');%  optvar
	
	soutput{10} = get(findobj('Tag','tab3edittext1'),'String'); %nx
	soutput{11} = get(findobj('Tag','tab3edittext2'),'String'); %nu
	soutput{12} = get(findobj('Tag','tab3edittext3'),'String'); %np
	soutput{13} = get(findobj('Tag','tab3edittext4'),'String'); %ncolx
	soutput{14} = get(findobj('Tag','tab3edittext5'),'String'); %ncolu
	soutput{15} = get(findobj('Tag','tab3edittext6'),'String'); %li
	soutput{16} = get(findobj('Tag','tab3edittext7'),'String'); %bdx
	soutput{17} = get(findobj('Tag','tab3edittext8'),'String'); %bdu
	soutput{18} = get(findobj('Tag','tab3edittext9'),'String'); %bdp
	soutput{19} = get(findobj('Tag','tab3edittext10'),'String'); %multistart
	soutput{20} = get(findobj('Tag','tab3edittext11'),'String'); %tf
	soutput{21} = get(findobj('Tag','tab3edittext12'),'String');% path to data
	
	soutput{22} = get(findobj('Tag','tab4list1'),'String');% objfun
	soutput{23} = get(findobj('Tag','tab4edittext1'),'String');% x0
	soutput{24} = get(findobj('Tag','tab4edittext2'),'String');% p0
	soutput{25} = get(findobj('Tag','tab4edittext3'),'String');% M
	soutput{26} = get(findobj('Tag','tab4edittext4'),'String');% ui
	soutput{27} = get(findobj('Tag','tab4list3'),'String');% proces
	
	soutput{28} = get(findobj('Tag','tab5list1'),'String');% ceqt0
	soutput{29} = get(findobj('Tag','tab5list2'),'String');% ct0
	
	soutput{30} = get(findobj('Tag','tab6list1'),'String');% ceqt0tf
	soutput{31} = get(findobj('Tag','tab6list2'),'String');% ct0tf
	
	soutput{32} = get(findobj('Tag','tab7list1'),'String');% ceqtf
	soutput{33} = get(findobj('Tag','tab7list2'),'String');% ctf
	
    if length(filename) > 5
        match = filename(end-3:end);
        if strcmp(match,'.dop')
            fn = [pathname filename];
        else
            fn = [pathname filename '.dop'];
        end
    else
        fn = [pathname filename '.dop'];
    end
	save(fn,'soutput','-mat');
end
%=========================================================================%

%=========================================================================%
%load it back!
function loadproblem(file)
tmp = load(file,'-mat');
soutput = tmp.soutput;

%set(findobj('Tag','tab2radio8'),'UserData',soutput{1}); % display: iter or off
ho = [findobj('Tag','tab2radio8') findobj('Tag','tab2radio9')];
set(ho,'Value',0);
set(ho(soutput{1}),'Value',1);
set(ho(soutput{1}),'UserData',1);
set(ho,'Callback',{@radioswitch,ho});


set(findobj('Tag','tab2edit1'),'String',soutput{2}); % MaxFunEvals
set(findobj('Tag','tab2edit2'),'String',soutput{3}); % MaxIter
set(findobj('Tag','tab2edit3'),'String',soutput{4}); % TolFun
set(findobj('Tag','tab2edit4'),'String',soutput{5}); % TolCon
set(findobj('Tag','tab2edit5'),'String',soutput{6}); % TolX

% set(findobj('Tag','tab1radio1'),'UserData',soutput{7});%  optvar
% ho = [findobj('Tag','tab1radio1') findobj('Tag','tab1radio2') findobj('Tag','tab1radio3')];
% set(ho,'Value',0);
% set(ho(soutput{7}),'Value',1);

cf1 = soutput{8};
cf2 = soutput{9};
hg1 = [findobj('Tag','tab2radio1') findobj('Tag','tab2radio2') findobj('Tag','tab2radio3')];
hg2 = [findobj('Tag','tab2radio4') findobj('Tag','tab2radio5') findobj('Tag','tab2radio6') findobj('Tag','tab2radio7')];
if (isempty(cf2)&&~isempty(cf1))
    set(hg1,'Value',0);
    set(hg1(cf1),'Value',1);
    set(hg1(1),'UserData',cf1);
    set(hg2,'Enable','off');
    set(hg2,'Value',0);
    set(hg1,'Callback',{@radioswitch,hg1});
end
if (isempty(cf1)&&~isempty(cf2))
    set(hg2,'Value',0);
    set(hg2(cf2),'Value',1);
    set(hg2(1),'UserData',cf2);
    set(hg1,'Enable','off');
    set(hg1,'Value',0);
    set(hg2,'Callback',{@radioswitch,hg2});
end

% set(findobj('Tag','tab2radio1'),'UserData',soutput{8});%  optvar
% set(findobj('Tag','tab2radio4'),'UserData',soutput{9});%  optvar

set(findobj('Tag','tab3edittext1'),'String',soutput{10}); %nx
set(findobj('Tag','tab3edittext2'),'String',soutput{11}); %nu
set(findobj('Tag','tab3edittext3'),'String',soutput{12}); %np
set(findobj('Tag','tab3edittext4'),'String',soutput{13}); %ncolx
set(findobj('Tag','tab3edittext5'),'String',soutput{14}); %ncolu
set(findobj('Tag','tab3edittext6'),'String',soutput{15}); %li
set(findobj('Tag','tab3edittext7'),'String',soutput{16}); %bdx
set(findobj('Tag','tab3edittext8'),'String',soutput{17}); %bdu
set(findobj('Tag','tab3edittext9'),'String',soutput{18}); %bdp
set(findobj('Tag','tab3edittext10'),'String',soutput{19}); %multistart
set(findobj('Tag','tab3edittext11'),'String',soutput{20}); %tf
set(findobj('Tag','tab3edittext12'),'String',soutput{21});% path to data

set(findobj('Tag','tab4list1'),'String',soutput{22});% objfun
set(findobj('Tag','tab4edittext1'),'String',soutput{23});% x0
set(findobj('Tag','tab4edittext2'),'String',soutput{24});% p0
set(findobj('Tag','tab4edittext3'),'String',soutput{25});% M
set(findobj('Tag','tab4edittext4'),'String',soutput{26});% ui
set(findobj('Tag','tab4list3'),'String',soutput{27});% proces

set(findobj('Tag','tab5list1'),'String',soutput{28});% ceqt0
set(findobj('Tag','tab5list2'),'String',soutput{29});% ct0

set(findobj('Tag','tab6list1'),'String',soutput{30});% ceqt0tf
set(findobj('Tag','tab6list2'),'String',soutput{31});% ct0tf

set(findobj('Tag','tab7list1'),'String',soutput{32});% ceqtf
set(findobj('Tag','tab7list2'),'String',soutput{33});% ctf
%=========================================================================%

%=========================================================================%
%load it back!
function emptyproblem(n)

hg = [findobj('Tag','tab2radio1') findobj('Tag','tab2radio2') findobj('Tag','tab2radio3') findobj('Tag','tab2radio4') findobj('Tag','tab2radio5') findobj('Tag','tab2radio6') findobj('Tag','tab2radio7') findobj('Tag','tab2radio8') findobj('Tag','tab2radio9')];
set(hg,'Value',0);
set(hg,'UserData',[]);

set(findobj('Tag','tab2edit1'),'String','1e5'); % MaxFunEvals
set(findobj('Tag','tab2edit2'),'String','1e5'); % MaxIter
set(findobj('Tag','tab2edit3'),'String','1e-7'); % TolFun
set(findobj('Tag','tab2edit4'),'String','1e-7'); % TolCon
set(findobj('Tag','tab2edit5'),'String','1e-7'); % TolX

set(findobj('Tag','tab3edittext1'),'String',[]); %nx
set(findobj('Tag','tab3edittext2'),'String',[]); %nu
set(findobj('Tag','tab3edittext3'),'String',[]); %np
set(findobj('Tag','tab3edittext4'),'String',[]); %ncolx
set(findobj('Tag','tab3edittext5'),'String',[]); %ncolu
set(findobj('Tag','tab3edittext6'),'String',[]); %li
set(findobj('Tag','tab3edittext7'),'String',[]); %bdx
set(findobj('Tag','tab3edittext8'),'String',[]); %bdu
set(findobj('Tag','tab3edittext9'),'String',[]); %bdp
set(findobj('Tag','tab3edittext10'),'String',[]); %multistart
set(findobj('Tag','tab3edittext11'),'String',[]); %tf
set(findobj('Tag','tab3edittext12'),'String',[]);% path to data

set(findobj('Tag','tab4list1'),'String',[]);% objfun
set(findobj('Tag','tab4edittext1'),'String',[]);% x0
set(findobj('Tag','tab4edittext2'),'String',[]);% p0
set(findobj('Tag','tab4edittext3'),'String',[]);% M
set(findobj('Tag','tab4edittext4'),'String',[]);% ui
set(findobj('Tag','tab4list3'),'String',[]);% proces
set(findobj('Tag','tab5list1'),'String',[]);% ceqt0
set(findobj('Tag','tab5list2'),'String',[]);% ct0
set(findobj('Tag','tab6list1'),'String',[]);% ceqt0tf
set(findobj('Tag','tab6list2'),'String',[]);% ct0tf
set(findobj('Tag','tab7list1'),'String',[]);% ceqtf
set(findobj('Tag','tab7list2'),'String',[]);% ctf
%=========================================================================%

%=========================================================================%
%evaluate when next button is pressed
function flag = nexttab(mh,content,tabnum)
flag=1;
if tabnum == 1
    olddata = get(mh,'UserData');
    data{1} = {'Dialog',[];'File',[]};
    confirmed = get(findobj('Tag','tab1radio1'),'UserData');
    ret(1) = findobj('Tag','tab2radio1');
    ret(2) = findobj('Tag','tab2radio2');
    ret(3) = findobj('Tag','tab2radio3');
    ret(4) = findobj('Tag','tab2radio4');
    ret(5) = findobj('Tag','tab2radio5');
    ret(6) = findobj('Tag','tab2radio6');
    ret(7) = findobj('Tag','tab2radio7');
    ret(8) = findobj('Tag','tab2radio8');
    ret(9) = findobj('Tag','tab2radio9');
    if (isempty(olddata{1}{1,2})&&isempty(olddata{1}{2,2}))
        if (confirmed == 3)
            [filename, pathname] = uigetfile('*.dop', 'Load Dynamic Optimisation Problem');
            if isequal(filename,0)|isequal(pathname,0)
                flag = 0;
            else
                data{1}{1,2} = 1;
                data{1}{2,2} = [pathname filename];
                flag = 1;
                new = 0;
                loadproblem([pathname filename]);
			end
        set(mh,'UserData',data);    
        end
        if (confirmed == 2)
            set(ret(8:9),'Value',0);
            set(ret(8),'Value',1);
            set(ret(8),'UserData',1); 
            set(ret(8:9),'Callback',{@radioswitch,ret(8:9)});
            
            set(ret(1:7),'Value',0);
            set(ret(4),'Value',1);
            set(ret(4),'UserData',1);
            set(ret(1),'UserData',[]);
            set(ret(1:3),'Enable','Off');
            set(ret(4:7),'Callback',{@radioswitch,ret(4:7)});
            set(ret(4:7),'Enable','On');            
        end
        if (confirmed == 1)
            set(ret(8:9),'Value',0);
            set(ret(8),'Value',1);
            set(ret(8),'UserData',1);
            set(ret(8:9),'Callback',{@radioswitch,ret(8:9)});
            
            set(ret(1:7),'Value',0);
            set(ret(1),'Value',1);
            set(ret(1),'UserData',1);
            set(ret(4),'UserData',[]);
            set(ret(1:3),'Enable','On');
            set(ret(1:3),'Callback',{@radioswitch,ret(1:3)});
            set(ret(4:7),'Enable','Off');
        end
    else
        button = questdlg('Do you want overwrite current inputs?','Overwrite','Yes','No','No');
        if strcmp(button,'Yes')
            data = get(mh,'UserData');
            if (confirmed == 3)
                [filename, pathname] = uigetfile('*.dop', 'Load Dynamic Optimisation Problem');
                if isequal(filename,0)|isequal(pathname,0)
                    flag = 0;
                else
                    data{1}{1,2} = 1;
                    data{1}{2,2} = strcat(pathname, filename);
                    flag = 1;
                    new = 0;
                    loadproblem([pathname filename]);
				end
                set(mh,'UserData',data);
            end
            if (confirmed == 2)
                emptyproblem(1);
                data{1} = {'Dialog',[];'File',[]};
                set(mh,'UserData',data);

                set(ret(8:9),'Value',0);
                set(ret(8),'Value',1);
                set(ret(8),'UserData',1);
                set(ret(8:9),'Callback',{@radioswitch,ret(8:9)});
                
                set(ret(1:7),'Value',0);
                set(ret(1),'Value',1);
                set(ret(1),'UserData',1);
                set(ret(4),'UserData',[]);
                set(ret(1:3),'Enable','On');
                set(ret(1:3),'Callback',{@radioswitch,ret(1:3)});
                set(ret(4:7),'Enable','Off');
            end
            if (confirmed == 1)
                emptyproblem(1);
                data{1} = {'Dialog',[];'File',[]};
                set(mh,'UserData',data);

                set(ret(8:9),'Value',0);
                set(ret(8),'Value',1);
                set(ret(8),'UserData',1);
                set(ret(8:9),'Callback',{@radioswitch,ret(8:9)});
                
                set(ret(1:7),'Value',0);
                set(ret(1),'Value',1);
                set(ret(1),'UserData',1);
                set(ret(4),'UserData',[]);
                set(ret(1:3),'Enable','On');
                set(ret(1:3),'Callback',{@radioswitch,ret(1:3)});
                set(ret(4:7),'Enable','Off');              
            end
        end    
        if strcmp(button,'No')
            flag =  1;
        end
    end
end

if tabnum == 2
    
        cf1 = get(findobj('Tag','tab2radio1'),'UserData');
        cf2 = get(findobj('Tag','tab2radio4'),'UserData') + 3;
        if (isempty(cf2)&&~isempty(cf1))
            confirmed = cf1;
        end
        if (isempty(cf1)&&~isempty(cf2))
            confirmed = cf2;
        end
        
        ret(1) = findobj('Tag','tab3edittext1'); %nx
        ret(2) = findobj('Tag','tab3edittext2'); %nu
        ret(3) = findobj('Tag','tab3edittext3'); %np
        ret(4) = findobj('Tag','tab3edittext4'); %ncolx
        ret(5) = findobj('Tag','tab3edittext5'); %ncolu
        ret(6) = findobj('Tag','tab3edittext6'); %li
        ret(7) = findobj('Tag','tab3edittext7'); %bdx
        ret(8) = findobj('Tag','tab3edittext8'); %bdu
        ret(9) = findobj('Tag','tab3edittext9'); %bdp
        ret(10) = findobj('Tag','tab3edittext10'); %multistart
        ret(11) = findobj('Tag','tab3edittext11'); %tf
        ret(12) = findobj('Tag','tab3edittext12'); %mdata path
        ret(13) = findobj('Tag','tab4edittext2'); %p0

        cmdawson = [ret(1) ret(2) ret(4) ret(5) ret(7)];
        switch confirmed
            case 1 % optimise times
                cmdon = [ret(6) ret(11)];
                cmdoff = [ret(8) ret(10) ret(3) ret(9) ret(12) ret(13)];
            case 2 % optimise control
                cmdon = [ret(6) ret(8) ret(10)];
                cmdoff = [ ret(3) ret(9) ret(12) ret(11) ret(13)];
            case 3 % optimise times and control
                cmdon = [ret(6) ret(8)  ret(10) ret(11)];
                cmdoff = [ret(3) ret(9) ret(12) ret(13)];
            case 4 % optimise parameters
                cmdon = [ret(6) ret(3) ret(9) ret(12) ret(13) ret(10)];
                cmdoff = [ret(8) ret(11)];
            case 5 % optimise times and parameters
                cmdon = [ret(6) ret(3) ret(9) ret(12) ret(13) ret(10)];
                cmdoff = [ret(8) ret(11)];
            case 6 % optimise controls and parameters
                cmdon = [ret(6) ret(8) ret(3) ret(9) ret(12) ret(13) ret(10)];
                cmdoff = [ret(11)];
            case 7 % optimise times, controls, parameters
                cmdon = [ret(6) ret(8) ret(3) ret(9) ret(12) ret(13) ret(10)];
                cmdoff = [ret(11)];
        end
        set([cmdawson cmdon],'BackgroundColor',[1 1 1]);
        set([cmdawson cmdon],'ForegroundColor',[0.5 0.5 0.4]);
        set([cmdawson cmdon],'Enable','on');
        set(ret(12),'Enable','inactive');        
        set([cmdoff],'BackgroundColor',[0.9 0.9 0.9]);
        set([cmdoff],'ForegroundColor',[0.3 0.3 0.3]);
        set([cmdoff],'Enable','off');
        set([cmdoff],'String',[]);
    end
if tabnum == 3
	errmsg = {
             'Number of states is empty or not a numeric scalar.'
             'Number of controls is empty or not a numeric scalar.'
             'Number of parameters is empty or not a numeric scalar.'
             'Number of collocation points for states is empty or not a numeric scalar.'
             'Number of collocation points for control is empty or not a numeric scalar.'
             'Intervals width is empty or not a numeric vector.'
             'Bounds for states is not a numeric matrix with two columns and number of states rows.'
             'Bounds for controls is not a numeric matrix with two columns and number of controls rows or Multistart is not empty.'
             'Bounds for parameters is not a numeric matrix with two columns and number of parameters rows or Multistart is not empty.'
             'Multistart should be positive numeric value.'
             'Final time should be positive numeric value.'
             'Path to measured data are not setted.'
            };    
	
	nu = 0;
    nx = 0;
    np = 0;
	b = str2num(get(findobj('Tag','tab3edittext2'),'String'));
	if ((~isempty(b))&&(isnumeric(b))&&(b>0))
        nu = b;
	end
	b = str2num(get(findobj('Tag','tab3edittext1'),'String'));
	if ((~isempty(b))&&(isnumeric(b))&&(b>0))
        nx = b;
	end
	b = str2num(get(findobj('Tag','tab3edittext3'),'String'));
	if ((~isempty(b))&&(isnumeric(b))&&(b>0))
        np = b;
	end
	
    
    % first column: nrow or [] for vector
    % second column: ncol or [] for vector
    % third column: ispossitive check
    % fourth column: isempty pass
	rules = {
             1 1 1 1;   %nx
             1 1 1 1;   %nu
             1 1 1 1;   %np
             1 1 1 1;   %ncolx
             1 1 1 [];  %ncolu
             1 [] 1 1;  %li
             nx 2 0 []; %bdx
             nu 2 0 []; %bdu
             np 2 0 []; %bdp
             1 1 1 [];   %multistart
             1 1 1 [];  %tf
            };

    cf1 = get(findobj('Tag','tab2radio1'),'UserData');
    cf2 = get(findobj('Tag','tab2radio4'),'UserData') + 3;
    multi = get(findobj('Tag','tab3edittext10'),'String');
%     if (isempty(cf2)&&~isempty(cf1)&&~isempty(multi))
%         if cf1 == 2
%             rules{8,4} = 1;
%         end
%         if cf1 == 3
%             rules{8,4} = 1;
%         end
%     end
    if (isempty(cf1)&&~isempty(cf2)&&~isempty(multi))
        if cf2 == 4
            rules{9,4} = 1;
        end
        if cf2 == 5
            rules{9,4} = 1;
        end
        if cf2 == 6
            %rules{8,4} = 1;
            rules{9,4} = 1;
        end
        if cf2 == 7
            %rules{8,4} = 1;
            rules{9,4} = 1;
        end
    end

	result = get(content(14:24),'String');
    enabled = get(content(14:24),'Enable');
	err = ones(length(result)+1,1);
	for i=1:1:length(result)
        if strcmp(enabled(i),'on')
            err(i) = testnumericeditfields(result{i},rules{i,1},rules{i,2},rules{i,3},rules{i,4});
        end
    end
    
    %path to measured data
    hdata = findobj('Tag','tab3edittext12');
    vdata = get(hdata,'String');
    edata = get(hdata,'Enable');
    if ((strcmp(vdata,''))&&(strcmp(edata,'inactive')))
        err(end) = 0;
    end


    strerr = [];
	for i=1:1:length(err)
        if err(i) == 0
            strerr = sprintf('%s\n%s',strerr,errmsg{i});
        end
	end
	
    if ~isempty(strerr)
		warndlg(strerr);
		flag = 0;
	else
        flag = 1;
	end
end
if tabnum == 4
	errmsg = {
             'Objective function is missing or bad entered.'
             'Initial condition for states is not a numeric vector of 1-nx size.'
             'Initial condition for parameters is not a numeric vector of 1-np size.'
             'Mass matrix is not a square matrix nx-nx.'
             'Initial control values is not a numeric vector of nu-nli size.'
             'ODE or DAE system description is missing or number of equations is not nx or bad entered.'
                };    
	
	nu = 0;
    nx = 0;
    np = 0;
	b = str2num(get(findobj('Tag','tab3edittext2'),'String'));
	if ((~isempty(b))&&(isnumeric(b))&&(b>0))
        nu = b;
	end
	b = str2num(get(findobj('Tag','tab3edittext1'),'String'));
	if ((~isempty(b))&&(isnumeric(b))&&(b>0))
        nx = b;
	end
	b = str2num(get(findobj('Tag','tab3edittext3'),'String'));
	if ((~isempty(b))&&(isnumeric(b))&&(b>0))
        np = b;
	end
	
    cmd = sprintf('%s;',get(findobj('Tag','tab3edittext6'),'String'));
    res = eval(cmd);
    nli = length(res);

    % first column: nrow or [] for vector
    % second column: ncol or [] for vector
    % third column: ispossitive check
    % fourth column: isempty pass
	rules = {
             [] [] [] []    %empty position
             1 nx 0 1;      %x0
             np 1 0 1;      %p0
             nx nx 0 [];    %M
             nu nli 0 [];   %ui
            };

	cf1 = get(findobj('Tag','tab2radio1'),'UserData');
	cf2 = get(findobj('Tag','tab2radio4'),'UserData')+3;
	if (isempty(cf2)&&~isempty(cf1))
        if ((cf1 == 2)||(cf1 == 3)) % controls are optimised
            rules{5,4} = 1;
        end
        if (cf1 == 1) 
            rules{5,4} = [];
        end
	end
	if (isempty(cf1)&&~isempty(cf2))
        if ((cf2 == 4)||(cf2 == 5))
            rules{5,4} = [];
        end
        if ((cf2 == 6)||(cf2 == 7)) % controls are optimised
            rules{5,4} = 1;
        end
	end
    
 	result = get(content(18:21),'String');
    enabled = get(content(18:21),'Enable');
	err = ones(length(result)+2,1);

    vobjfun = get(content(2),'String');
    if strcmp(vobjfun,'')
        err(1) = 0;
    else
        err(1) = eqvalidity(vobjfun,1);
    end
    
    for i=2:1:length(result)+1
        if strcmp(enabled(i-1),'on')
            err(i) = testnumericeditfields(result{i-1},rules{i,1},rules{i,2},rules{i,3},rules{i,4});
        end
    end

    vsystem = get(content(7),'String');
    neq = length(vsystem);
    if strcmp(vobjfun,'')
        err(end) = 0;
    else
        err(end) = eqvalidity(vsystem,2);
    end
    if neq ~= nx
        err(end) = 0;
    end
    
    strerr = [];
	for i=1:1:length(err)
        if err(i) == 0
            strerr = sprintf('%s\n%s',strerr,errmsg{i});
        end
	end
	
    if ~isempty(strerr)
		warndlg(strerr);
		flag = 0;
	else
        flag = 1;
	end
end

if tabnum == 5
	errmsg = {
             'Equality constraints applied at initial time are bad entered.'
             'Inequality constraints applied at initial time are bad entered.'
                };  

    err = ones(2,1);                

    vceqt0 = get(content(4),'String');
    if ~strcmp(vceqt0,'')
        err(1) = eqvalidity(vceqt0,2);
    end
    vct0 = get(content(5),'String');
    if ~strcmp(vct0,'')    
        err(2) = eqvalidity(vct0,2);
    end
    
    
    strerr = [];
	for i=1:1:length(err)
        if err(i) == 0
            strerr = sprintf('%s\n%s',strerr,errmsg{i});
        end
	end
	
    if ~isempty(strerr)
		warndlg(strerr);
		flag = 0;
	else
        flag = 1;
	end
end

if tabnum == 6
	errmsg = {
             'Equality constraints applied between initial and final time are bad entered.'
             'Inequality constraints applied between initial and final time are bad entered.'
                };  

    err = ones(2,1);                

    vceqt0tf = get(content(4),'String');
    if ~strcmp(vceqt0tf,'')    
        err(1) = eqvalidity(vceqt0tf,2);
    end
    vct0tf = get(content(5),'String');
    if ~strcmp(vct0tf,'')
        err(2) = eqvalidity(vct0tf,2);
    end
    
    
    strerr = [];
	for i=1:1:length(err)
        if err(i) == 0
            strerr = sprintf('%s\n%s',strerr,errmsg{i});
        end
	end
	
    if ~isempty(strerr)
		warndlg(strerr);
		flag = 0;
	else
        flag = 1;
	end
end

if tabnum == 7
	errmsg = {
             'Equality constraints applied at final time are bad entered.'
             'Inequality constraints applied at final time are bad entered.'
                };  

    err = ones(2,1);                

    vceqtf = get(content(4),'String');
    if ~strcmp(vceqtf,'')
        err(1) = eqvalidity(vceqtf,2);
    end
    vctf = get(content(5),'String');
    if ~strcmp(vctf,'')    
        err(2) = eqvalidity(vctf,2);
    end
    
    
    strerr = [];
	for i=1:1:length(err)
        if err(i) == 0
            strerr = sprintf('%s\n%s',strerr,errmsg{i});
        end
	end
	
    if ~isempty(strerr)
		warndlg(strerr);
		flag = 0;
	else
        flag = 1;
	end
end

if tabnum == 8
%============================================================================================%    
%  OPTIONS
%============================================================================================%
    output{1} = 'clear all';
    output{end+1} = 'options = optimset(''GradObj'',''on'',''GradConstr'',''on'');';

    if get(findobj('Tag','tab2radio8'),'UserData') == 1
        output{end+1} = 'options = optimset(options,''LargeScale'',''off'',''Display'',''iter'');';
    end
    if get(findobj('Tag','tab2radio8'),'UserData') == 2
        output{end+1} = 'options = optimset(options,''LargeScale'',''off'',''Display'',''off'');';
    end
    output{end+1} = sprintf('options = optimset(options,''MaxFunEvals'',%s);',get(findobj('Tag','tab2edit1'),'String'));
    output{end+1} = sprintf('options = optimset(options,''MaxIter'',%s);',get(findobj('Tag','tab2edit2'),'String'));
    output{end+1} = sprintf('options = optimset(options,''TolFun'',%s);',get(findobj('Tag','tab2edit3'),'String'));
    output{end+1} = sprintf('options = optimset(options,''TolCon'',%s);',get(findobj('Tag','tab2edit4'),'String'));
    output{end+1} = sprintf('options = optimset(options,''TolX'',%s);',get(findobj('Tag','tab2edit5'),'String'));
    output{end+1} = 'symdynoptparam.optimparam.options = options;';
%============================================================================================%
%  OPTIMPARAM
%============================================================================================%
    cf1 = get(findobj('Tag','tab2radio1'),'UserData');
	cf2 = get(findobj('Tag','tab2radio4'),'UserData')+3;
	if (isempty(cf2)&&~isempty(cf1))
        confirmed = cf1;
    end
	if (isempty(cf1)&&~isempty(cf2))
        confirmed = cf2;
    end
    output{end+1} = sprintf('symdynoptparam.optimparam.optvar = %d;',confirmed);
    
    path = get(findobj('Tag','tab3edittext12'),'String');
    if ~strcmp(path,'')
        data = eval(sprintf('load(''%s'',''ascii'');',path));
        [r,c]=size(data);
        output{end+1} = sprintf('data = load(''%s'',''ascii'');',path);
        output{end+1} = sprintf('objtype.tm = data(:,1)'';');
        output{end+1} = sprintf('objtype.xm = data(:,2:%d)'';',c);
        output{end+1} = sprintf('symdynoptparam.optimparam.objtype = objtype;',c);
    else
        output{end+1} = 'symdynoptparam.optimparam.objtype = [];';
    end

    output{end+1} = sprintf('symdynoptparam.optimparam.ncolx = %s;',get(findobj('Tag','tab3edittext4'),'String'));
    ncolu = get(findobj('Tag','tab3edittext5'),'String');
    if strcmp(ncolu,'')
        output{end+1} = sprintf('symdynoptparam.optimparam.ncolu = [];');
    else
        output{end+1} = sprintf('symdynoptparam.optimparam.ncolu = %s;',ncolu);
    end
    output{end+1} = sprintf('symdynoptparam.optimparam.li = %s'';',get(findobj('Tag','tab3edittext6'),'String'));

    tf = get(findobj('Tag','tab3edittext11'),'String');
    if ~strcmp(tf,'')
        output{end+1} = sprintf('symdynoptparam.optimparam.tf = %s;',tf);
    else
        output{end+1} = 'symdynoptparam.optimparam.tf = [];';
    end
    ui = get(findobj('Tag','tab4edittext4'),'String');
    if ~strcmp(ui,'')
        output{end+1} = sprintf('symdynoptparam.optimparam.ui = %s;',ui);
    else
        output{end+1} = 'symdynoptparam.optimparam.ui = [];';
    end   
    
    par = get(findobj('Tag','tab4edittext2'),'String');
    if ~strcmp(par,'')
        output{end+1} = sprintf('symdynoptparam.optimparam.par = %s;',par);
    else
        output{end+1} = sprintf('symdynoptparam.optimparam.par = [];');
    end

    bdx = get(findobj('Tag','tab3edittext7'),'String');
    if ~strcmp(bdx,'')
        output{end+1} = sprintf('symdynoptparam.optimparam.bdx = %s;',bdx);
    else
        output{end+1} = 'symdynoptparam.optimparam.bdx = [];';
    end
    bdu = get(findobj('Tag','tab3edittext8'),'String');
    if ~strcmp(bdu,'')
        output{end+1} = sprintf('symdynoptparam.optimparam.bdu = %s;',bdu);
    else
        output{end+1} = 'symdynoptparam.optimparam.bdu = [];';
    end
    bdp = get(findobj('Tag','tab3edittext9'),'String');
    if ~strcmp(bdp,'')
        output{end+1} = sprintf('symdynoptparam.optimparam.bdp = %s;',bdp);
    else
        output{end+1} = 'symdynoptparam.optimparam.bdp = [];';
    end
 
    multi = get(findobj('Tag','tab3edittext10'),'String');
    if ~strcmp(multi,'')
        output{end+1} = sprintf('symdynoptparam.multistart.it = %s;',multi);
    else
        output{end+1} = sprintf('symdynoptparam.multistart.it = [];');
    end
    
    bdp = get(findobj('Tag','tab3edittext9'),'String');
    if ~strcmp(bdp,'')
        output{end+1} = sprintf('symdynoptparam.multistart.bdp = %s;',bdp);
    else
        output{end+1} = 'symdynoptparam.multistart.bdp = [];';
    end

    bdu = get(findobj('Tag','tab3edittext8'),'String');
    if ~strcmp(bdu,'')
        output{end+1} = sprintf('symdynoptparam.multistart.bdu = %s;',bdu);
    else
        output{end+1} = 'symdynoptparam.multistart.bdu = [];';
    end
    
    M = get(findobj('Tag','tab4edittext3'),'String');
    if ~strcmp(M,'')
        output{end+1} = sprintf('symdynoptparam.M = %s;',M);
    else
        output{end+1} = 'symdynoptparam.M = [];';
    end
    
    cmd = sprintf('%s;',get(findobj('Tag','tab4edittext1'),'String'));
    res = eval(cmd);nx0 = length(res);
    output{end+1} = sprintf('symdynoptparam.eq.x0 = [');
    for i = 1:1:nx0
        output{end+1} = sprintf('                           {''%.20d''}',res(i));
    end
    output{end+1} = sprintf('                           ];');
    
    robjfun = get(findobj('Tag','tab4list1'),'String');
    output{end+1} = sprintf('symdynoptparam.eq.objfun = [{''%s''}];',robjfun);
    
    output{end+1} = sprintf('symdynoptparam.eq.shortcuts = [];');
    
    rprocess = get(findobj('Tag','tab4list3'),'String');
    output{end+1} = sprintf('symdynoptparam.eq.process = [');
    for i = 1:1:length(rprocess)
        output{end+1} = sprintf('                           {''%s''}',rprocess{i});
    end    
    output{end+1} = sprintf('                                ];');
    
    rceqt0 = get(findobj('Tag','tab5list1'),'String');
    n = length(rceqt0);
    output{end+1} = sprintf('symdynoptparam.eq.confun.ceq.t0 = [');
    if n > 0
        for i = 1:1:n
            output{end+1} = sprintf('                           {''%s''}',rceqt0{i});
        end
    end
    output{end+1} = sprintf('                                ];');
    
    rct0 = get(findobj('Tag','tab5list2'),'String');
    n = length(rct0);
    output{end+1} = sprintf('symdynoptparam.eq.confun.c.t0 = [');
    if n > 0
        for i = 1:1:n
            output{end+1} = sprintf('                           {''%s''}',rct0{i});
        end
    end
    output{end+1} = sprintf('                                ];');

    rceqt0tf = get(findobj('Tag','tab6list1'),'String');
    n = length(rceqt0tf);
    output{end+1} = sprintf('symdynoptparam.eq.confun.ceq.t0tf = [');
    if n > 0
        for i = 1:1:n
            output{end+1} = sprintf('                           {''%s''}',rceqt0tf{i});
        end
    end
    output{end+1} = sprintf('                                ];');
    
    rct0tf = get(findobj('Tag','tab6list2'),'String');
    n = length(rct0tf);
    output{end+1} = sprintf('symdynoptparam.eq.confun.c.t0tf = [');
    if n > 0
        for i = 1:1:n
            output{end+1} = sprintf('                           {''%s''}',rct0tf{i});
        end
    end
    output{end+1} = sprintf('                                ];');

    rceqtf = get(findobj('Tag','tab7list1'),'String');
    n = length(rceqtf);
    output{end+1} = sprintf('symdynoptparam.eq.confun.ceq.tf = [');
    if n > 0
        for i = 1:1:n
            output{end+1} = sprintf('                           {''%s''}',rceqtf{i});
        end
    end
    output{end+1} = sprintf('                                ];');
    
    rctf = get(findobj('Tag','tab7list2'),'String');
    n = length(rctf);
    output{end+1} = sprintf('symdynoptparam.eq.confun.c.tf = [');
    if n > 0
        for i = 1:1:n
            output{end+1} = sprintf('                           {''%s''}',rctf{i});
        end
    end
    output{end+1} = sprintf('                                ];');   
    output{end+1} = sprintf('[symdynoptparam, symdynoptout] = symdynopt(symdynoptparam);');
    data = get(mh,'UserData');
    
    if ~isempty(data{1}{2,2})
        ff = data{1}{2,2};
        ff = [ff(1:end-4) '.mat'];
    else
        ff = 'new.mat';
    end
    output{end+1} = sprintf('save(''%s'',''symdynoptparam'',''symdynoptout'',''-mat'')',ff);
%============================================================================================%

fid = fopen('temp.m','W');
for i=1:1:length(output)   
    fprintf(fid,'%s\n',output{i});
end
fclose(fid);

run('temp');

delete('temp.m');
flag = 1;
end
%=========================================================================%

%=========================================================================%
%test equation passing through
function flag = eqvalidity(inputdata,code)
flag = 0;
if code == 1
    if isvalideval(inputdata,1)
		flag = testsymboliceditfield(inputdata,1);
    else
        flag = 0;
    end
end
if code == 2
    for i=1:1:length(inputdata)
        if isvalideval(inputdata{i},2)
			flg = testsymboliceditfield(inputdata{i},2);
        else
            flg = 0;
        end
        aa(i) = flg;
    end
    if aa == 1
        flag = 1;
    else
        flag = 0;
    end
end
%=========================================================================%

%=========================================================================%
%test for eval, avoiding of parsing any command
function flag = isvalideval(inputdata,type)
flag = [];
nu = 0;
b = str2num(get(findobj('Tag','tab3edittext2'),'String'));
if ((~isempty(b))&&(isnumeric(b))&&(b>0))
    nu = b;
end
nx = 0;
b = str2num(get(findobj('Tag','tab3edittext1'),'String'));
if ((~isempty(b))&&(isnumeric(b))&&(b>0))
    nx = b;
end
if type == 1
	
        res = givemesymb(nu,nx,0,1);
        kk = 0;
        i = 0;
        while kk == 0;
            i = i+1;
            o = strfind(inputdata,res{i});
            if ~isempty(o)
                kk = 1;
                flag = 1;
            end
            if i == length(res)
                kk = 2;
            end
        end

end
if type == 2
	np = 0;
	b = str2num(get(findobj('Tag','tab3edittext3'),'String'));
    if ((~isempty(b))&&(isnumeric(b))&&(b>0))
        np = b;
	end
        res = givemesymb(nu,nx,np,2);
        kk = 0;
        i = 0;
        while kk == 0;
            i = i+1;
            o = strfind(inputdata,res{i});
            if ~isempty(o)
                kk = 1;
                flag = 1;
            end
            if i == length(res)
                kk = 2;
            end
        end
end
if isempty(flag)    
    flag = 0;
end
%=========================================================================%

%=========================================================================%
%test symbolic entries
function flag = testsymboliceditfield(inpstr,type)
flag = [];
nu = 0;
b = str2num(get(findobj('Tag','tab3edittext2'),'String'));
if ((~isempty(b))&&(isnumeric(b))&&(b>0))
    nu = b;
end
nx = 0;
b = str2num(get(findobj('Tag','tab3edittext1'),'String'));
if ((~isempty(b))&&(isnumeric(b))&&(b>0))
    nx = b;
end
if type == 1
        [cmd,xcmd,ucmd,pcmd,tcmd,xmcmd] = makesymbcmd(nu,nx,0,1);
        eval(cmd);
        eval(xcmd);
        eval(xmcmd);
        eval(ucmd);
        eval(tcmd);
        try
            eval(sprintf('%s;',inpstr));
        catch
            flag = 0;
        end
end
if type == 2
	np = 0;
	b = str2num(get(findobj('Tag','tab3edittext3'),'String'));
    if ((~isempty(b))&&(isnumeric(b))&&(b>0))
        np = b;
	end
        [cmd,xcmd,ucmd,pcmd,tcmd,xmcmd] = makesymbcmd(nu,nx,np,2);
        eval(cmd);
        eval(xcmd);
        eval(ucmd);
        eval(pcmd);
        eval(tcmd);
        try
            eval(sprintf('%s;',inpstr));
        catch
            flag = 0;
        end
end
if isempty(flag)    
    flag = 1;
end
%=========================================================================%

%=========================================================================%
%products cell array with all variables
function res = givemesymb(nu,nx,np,type);
for i=1:1:nx
    if i > 0
        res{i} = sprintf('x(%d)',i);
    end
end
uu = '';
for j=nx:1:nx+nu
    if j-nx > 0
        res{j} = sprintf('u(%d)',j-nx);
    end
end
if type == 2
	for k=nx+nu:1:nx+nu+np
        if k-nx-nu>0
            res{k} = sprintf('p(%d)',k-nx-nu);
        end
	end
end
if type == 1
for i=1:1:nx
    if i > 0
        res{end+1} = sprintf('xm(%d)',i);
    end
end    
end
res{end+1} = 't(1)';
%=========================================================================%

%=========================================================================%
%make commands for symbolic
function [cmd,xcmd,ucmd,pcmd,tcmd,xmcmd] = makesymbcmd(nu,nx,np,type);
xx = '';
xm = '';
for i=1:1:nx
    xx = sprintf('%s x%d',xx,i);
    xm = sprintf('%s xm%d',xm,i);
end
uu = '';
for i=1:1:nu
    uu = sprintf('%s u%d',uu,i);
end
if type == 2
	pp = '';
	for i=1:1:np
        pp = sprintf('%s p%d',pp,i);
	end
    cmd = sprintf('syms t1%s%s%s;',xx,uu,pp);
    tcmd = sprintf('t = [t1];');
    xcmd = sprintf('x = [%s];',xx);
    xmcmd = sprintf('xm = [];');
    ucmd = sprintf('u = [%s];',uu);
    pcmd = sprintf('p = [%s];',pp);
end
if type == 1
    cmd = sprintf('syms t1%s%s%s;',xx,uu,xm);
    tcmd = sprintf('t = [t1];');
    xcmd = sprintf('x = [%s];',xx);
    xmcmd = sprintf('xm = [%s];',xm);
    ucmd = sprintf('u = [%s];',uu); 
    pcmd = '';
end
%=========================================================================%

%=========================================================================%
%test numeric edit fields
function flag = testnumericeditfields(in,nr,nc,pos,emptyness)

flag = 0;
if (isempty(emptyness)&&strcmp(in,''))
    check = ones(1,4);
end
if (~isempty(emptyness)&&strcmp(in,''))
    check = zeros(1,4);
end
if ((isempty(emptyness)&&~strcmp(in,''))||(~isempty(emptyness)&&~strcmp(in,'')))
	check = zeros(1,4);
	tmp = str2num(in);
	if isnumeric(tmp)
        check(1) = 1;
		[r,c] = size(tmp);
		if ~isempty(nr)
            if r == nr
                check(2) = 1;
            end
        else
            check(2) = 1;
        end
		if ~isempty(nc)
            if c == nc
                check(3) = 1;
            end
        else
            check(3) = 1;
        end
        if pos == 1
            if ((tmp>0)==(ones(r,c)))
                check(4) = 1;
            end
        end
        if pos == 0
            check(4) = 1;
        end
	end
end
if check == ones(1,4)
    flag = 1;
end
%=========================================================================%

%=========================================================================%
%evaluate when prev button is pressed
function flag = prevtab(mh,content,tabnum)
flag = 1;
%=========================================================================%

%=========================================================================%
%load data
function loadparamdata(obj,event,in)
data = get(in,'Enable');
errtest = 1;
if strcmp(data,'inactive')
    [filename, pathname] = uigetfile({'*.txt;','Text Files';},'Load measured data');
	if isequal(filename,0)|isequal(pathname,0)
        errtest = 2;
    else
        try
            eval(sprintf('''load %s -ascii;''',[pathname filename]));
		catch
            errtest = 0;
        end
    end
    if errtest == 0
        errordlg('Incorrect file format!');
    end
    if errtest == 1
        set(in,'String',[pathname filename]);
    end
end
%=========================================================================%

%=========================================================================%
%radiobutton rules
function radioswitch(obj,event,radioh)
position = get(radioh(1),'UserData');
set(radioh(position),'Value',0);
set(obj,'Value',1);
set(radioh(1),'UserData',find(radioh==obj));
%=========================================================================%

%=========================================================================%
%listboxes features
function tab2buttons(obj,event,handles,inputdata)
str = get(obj,'String');
tag = get(obj,'Tag');

if tag(end) == '1'
    cmd = [lower(str) tag(end)];
    obj = handles(str2num(tag(end)));
else
    cmd = [lower(str) '2'];
    obj = handles(str2num(tag(end)));
end

nx = 0;
b = str2num(get(findobj('Tag','tab3edittext1'),'String'));
if ((~isempty(b))&&(isnumeric(b))&&(b>0))
    nx = b;
end

switch cmd
    case 'edit1'
        inputdat = inptdl(inputdata{str2num(tag(end))}{1},{get(obj,'String')},inputdata{str2num(tag(end))}{2});
        if ~isempty(inputdat)
            set(obj,'String',inputdat);
        end
    case 'clear1'
        set(obj,'String','');
    case 'add2'
        cst = get(obj,'Value');
        data = get(obj,'String');
        inputdat = inptdl(inputdata{str2num(tag(end))}{1},{''},inputdata{str2num(tag(end))}{2});
        if ~isempty(inputdat)
            if (iscell(data)&&(~isempty(data)))
                res = {data{1:cst} inputdat data{cst+1:end}};
                set(obj,'String',res);
                set(obj,'Value',cst+1);
            else
                res = {inputdat};
                set(obj,'String',res);
                set(obj,'Value',cst);
            end
        end
    case 'edit2'
        pos = get(obj,'Value');
        data = get(obj,'String');
        if (iscell(data)&&(~isempty(data)))
            inputdat = inptdl(inputdata{str2num(tag(end))}{1},{data{pos}},inputdata{str2num(tag(end))}{2});
            if ~isempty(inputdat)
                data{pos} = inputdat;
                set(obj,'String',data);
            end
        end      
    case 'clear2'
        pos = get(obj,'Value');
        data = get(obj,'String');
        if (iscell(data)&&(~isempty(data)))
            nd = length(data);
            if pos == nd
                res = {data{1:pos-1};};
                if (pos-1) == 0
                    pos = 1;
                else
                    pos = pos - 1;
                end
                set(obj,'Value',pos);
                set(obj,'String',res);
            else
                res = {data{1:pos-1} data{pos+1:end}};
                set(obj,'Value',pos);
                set(obj,'String',res);
            end
        end
    case 'up2'
        pos = get(obj,'Value');
        data = get(obj,'String');
        if (iscell(data)&&(~isempty(data)))
            nd = length(data);
            if ((pos > 1)&&(pos<=nd))
                ndataup = data{pos};
                ndatadown = data{pos-1};
                data{pos} = ndatadown;
                data{pos-1} = ndataup;
                set(obj,'String',data);
                set(obj,'Value',pos-1);
            end
        end
    case 'down2'
        pos = get(obj,'Value');
        data = get(obj,'String');
        if (iscell(data)&&(~isempty(data)))
            nd = length(data);
            if ((pos >= 1)&&(pos<nd))
                ndataup = data{pos+1};
                ndatadown = data{pos};
                data{pos+1} = ndatadown;
                data{pos} = ndataup;
                set(obj,'String',data);
                set(obj,'Value',pos+1);
            end
        end
    case 'clear all2'
        set(obj,'Value',1);
        set(obj,'String',[]);
end
%=========================================================================%

%=========================================================================%
%input dialog for listboxes
function out = inptdl(prompt,def,dlgTitle)
lineNo = 1;
AddOpts.Resize = 'off';
AddOpts.WindowStyle = 'normal';
AddOpts.Interpreter = 'tex';
out = inputdlg(prompt,dlgTitle,lineNo,def,AddOpts);
%=========================================================================%

%=========================================================================%
%listboxes features
function incrementit(obj,event,handles)
tag = get(obj,'Tag');
num = str2num(tag(end-1:end));
btnrow = ceil(num/4);
btncol = mod(num,4);

tmptext = get(handles(btnrow),'String');
posofe = findstr(tmptext,'e');
var = str2num(tmptext(1:posofe-1));
evar = str2num(tmptext(posofe+1:end));
switch btncol 
    case 1
        if var < 20
            var = var + 1;
        end
    case 2
        if var > 1
            var = var - 1;
        end
    case 3
        if ((btnrow > 0)&&(btnrow < 3))
            if evar < 20
                evar = evar + 1;
            end
        end
        if ((btnrow > 2)&&(btnrow < 6))
            if evar < -1
                evar = evar + 1;
            end
        end
    case 0
        if ((btnrow > 0)&&(btnrow < 3))
            if evar > 1
                evar = evar - 1;
            end
        end
        if ((btnrow > 2)&&(btnrow < 6))
            if evar > -20
                evar = evar - 1;
            end
        end
end

res = [num2str(var) 'e' num2str(evar)];
set(handles(btnrow),'String',res);
%=========================================================================%









%=========================================================================%
%calculates figure window position aligned to center
function pos = retPosition(w,h)
screensize = get(0,'ScreenSize');
pos = [ceil(screensize(3)/2-w/2);ceil(screensize(4)/2-h/2);w;h]';
%=========================================================================%

%=========================================================================%
%sorts handles and create structure based on tags
function hstruct = handlerstructure(rootid)
objects = get(rootid,'Children');
for i=1:1:length(objects)
    eval(sprintf('hstruct.%s = %d;',get(objects(i),'Tag'),objects(i)))
end
%=========================================================================%

%=========================================================================%
%creates options input format for figure and uicontrols from provided
%structure
function str = struct2str(structure)
names = fieldnames(structure);
str = '';
for i=1:1:length(names)
    if ischar(getfield(structure,names{i}))
        str = sprintf('%s''%s'',''%s''',str,names{i},getfield(structure,names{i}));
    end
    if isnumeric(getfield(structure,names{i}))
        [r,c] = size(getfield(structure,names{i}));
        if ((r==1)&&(c==1))
            str = sprintf('%s''%s'',%d',str,names{i},getfield(structure,names{i}));
        else
            str = sprintf('%s''%s'',%s',str,names{i},makeString(getfield(structure,names{i})));
        end
    end
    if i ~= length(names)
        str = sprintf('%s,',str);
    end    
end
%=========================================================================%

%=========================================================================%
%generates string form of array
function out = makeString(datain)
if ~isempty(datain)
    r = size(datain,1);
    c = size(datain,2);
    out = sprintf('[');
    for i=1:1:r
        for j=1:1:c
            if ~isnumeric(datain(i,j))
                out = sprintf('%s%s ',out,char(datain(i,j)));
            else
                out = sprintf('%s%d ',out,datain(i,j));
            end
            
            if j ~= c
                out = sprintf('%s%s',out,',');
            end
        end
        out = sprintf('%s%s',out,';');
    end
    out = strcat(out,']');
else
    out = '[]';
end
%=========================================================================%