function [x_c,u_c,p_c,tauc,lfxc,lfuc,dlfxc,srs] = sevalcollpoints(xm,um,pm,optim_param)


tmes = optim_param.objtype.tm; %measured times
li = optim_param.li;
tauc = tmes'/tmes(end);
x_c = [];
u_c = [];
lfxc = [];
lfuc = [];
dlfxc = [];
srs = [];


% evaluating lagrange function at ni-1 intervals
for i=1:1:length(li)
    if i == 1
        lis1 = 0;
    else
        lis1 = sum(li(1:i-1));
    end
    lis2 = sum(li(1:i));
    
    if i == length(li)
        sr = eval(sprintf('find((tmes >= %d)&(tmes <= %d))',lis1,lis2));
    else
        sr = eval(sprintf('find((tmes >= %d)&(tmes < %d))',lis1,lis2));
    end
    
    srs = [srs;sr(end)];
    tau  = tmes(sr);
    taukx = [0;legroots(optim_param.ncolx)];
    taukxi = lis1+taukx*(lis2-lis1);
    [lfx,dlfx] = lagfun(tau,taukxi); % Lagrange functions for states
    tauku = legroots(optim_param.ncolu);
    taukui = lis1+tauku*(lis2-lis1);
    lfu = lagfun(tau,taukui);
    
    lfxc = [lfxc;lfx];
    lfuc = [lfuc;lfu];
    dlfxc = [dlfxc;dlfx];
    temp = length(tau);
    for j=1:temp
        if ~isempty(um)
            % nu-by-1 vector
            uj = reshape(um(:,i),optim_param.ncolu,optim_param.nu)'*lfu(j,:)';
            u_c = [u_c;uj'];
        end
        % nx-by-1 vector
        xj = reshape(xm(:,i),optim_param.ncolx+1,optim_param.nx)'*lfx(j,:)';
        x_c = [x_c;xj'];        
    end
end

% p_c - parameters in collocation point
if ~isempty(pm)
    p_c = pm;
else
    p_c = zeros(temp);
end


if isempty(um)
    if optim_param.nu == 0
        nu = 1;
    else
        nu = optim_param.nu;
    end
    u_c = zeros(length(tmes),nu);
end
