function symdynopt_param = makeGradients2(symdynopt_param)
%=========================================================================%
% MAIN FUNCTION
%=========================================================================%
% creating emptyfiles
fid = fopen('process.m','w');fclose(fid);
fid = fopen('objfun.m','w');fclose(fid);
fid = fopen('confun.m','w');fclose(fid);

% counting necessary variables
% symdynopt_param.np = length(symdynopt_param.optimparam.par);
% symdynopt_param.nx = size(symdynopt_param.eq.x0,1);
% symdynopt_param.nu = size(symdynopt_param.optimparam.ui,1);
%     
    if isempty(symdynopt_param.M)
        symdynopt_param.M = eye(symdynopt_param.nx); % ODE system
    end

%creating symbol base, to evaluate syms command and also for substitutions    
[cmd,x,xm,u,p,subfrom,subto] = createSymbolsBaseCmd(symdynopt_param);
%evaluating bases
subfrom = eval(subfrom);
subto = eval(subto);
eval(cmd);
eval(x);
eval(xm);
eval(u);
eval(p);
%evaluating also other substitutions defined in user file
scts = size(symdynopt_param.eq.shortcuts,1);
for i=1:1:scts
    cmd = sprintf('%s = %s;',symdynopt_param.eq.shortcuts{i,1},symdynopt_param.eq.shortcuts{i,2});
    eval(cmd);
end

for i=1:1:length(symdynopt_param.eq.process)
        symdynopt_param.eq.process{i} = char(subs(eval(symdynopt_param.eq.process{i}),subfrom,subto));
end



funcname = [
                {'x0'}
                {'f'}
                {'of'}
                {'ct0'}
                {'ceqt0'}
                {'ct0tf'}
                {'ceqt0tf'}
                {'ctf'}
                {'ceqtf'}
                ];
cmds = [
    {'x0'}
    {'process'}
    {'objfun'}
    {'confun.c.t0'}
    {'confun.ceq.t0'}
    {'confun.c.t0tf'}
    {'confun.ceq.t0tf'}
    {'confun.c.tf'}
    {'confun.ceq.tf'}
    ];

for i=1:1:length(cmds)
    cmdline = sprintf('%s = eval(funcProcess(symdynopt_param,''%s''));',funcname{i},cmds{i});
    eval(cmdline);
end


digits(4);
derivvars = [{'t'} {'x'} {'u'} {'p'}];
donecmd = 'donecmd = [';
for j=1:1:length(derivvars)
    for k=2:1:length(funcname)
        if eval(sprintf('((~isempty(%s))&&(~isempty(%s)))',derivvars{j},funcname{k}))
            eval(sprintf('symdynopt_param.eq.d%sd%s = makeEmptyBrackets(transpose(subs(jacobian(%s,%s),subfrom,subto)));',funcname{k},derivvars{j},funcname{k},derivvars{j}));
            donecmd = sprintf('%s{''d%sd%s''} ',donecmd,funcname{k},derivvars{j});
        else
            eval(sprintf('symdynopt_param.eq.d%sd%s = [];',funcname{k},derivvars{j}));
            donecmd = sprintf('%s{''d%sd%s''} ',donecmd,funcname{k},derivvars{j});
        end
    end
end

k=1;j=4;
        if eval(sprintf('((~isempty(%s))&&(~isempty(%s)))',derivvars{j},funcname{k}))
            eval(sprintf('symdynopt_param.eq.d%sd%s = makeEmptyBrackets(transpose(subs(jacobian(%s,%s),subfrom,subto)));',funcname{k},derivvars{j},funcname{k},derivvars{j}));
            donecmd = sprintf('%s{''d%sd%s''} ',donecmd,funcname{k},derivvars{j});
        else
            eval(sprintf('symdynopt_param.eq.d%sd%s = [];',funcname{k},derivvars{j}));
            donecmd = sprintf('%s{''d%sd%s''} ',donecmd,funcname{k},derivvars{j});
        end

donecmd = strcat(donecmd,']; ');
eval(donecmd);

% for i=1:1:length(donecmd)
%     eval(sprintf('%s = symdynopt_param.eq.%s',donecmd{i},donecmd{i}));
% end



%a = subs(symdynopt_param.eq.dfdx,subfrom,subto)


do_processfile(symdynopt_param);
do_objfunfile(symdynopt_param);
if checkConfunNeeds(symdynopt_param)
    do_confunfile(symdynopt_param);
end




function out = do_processfile(symdynopt_param)

%creating file
filename = 'process.m';

fid = fopen(filename,'W');

%writting into file
%header of m-file
fprintf(fid,'function sys = process(t,x,flag,u,p)\n');
fprintf(fid,'switch flag\n');

wfields = [
            {'f(x,u,p,t)'};
            {'df/dx'};
            {'df/du'};
            {'df/dp'};
            {'df/dt'};
            {'x0'};
            {'dx0/dp'};
            {'M'};
            ];
cmds = [
            {'eq.process'};
            {'eq.dfdx'};
            {'eq.dfdu'};
            {'eq.dfdp'};
            {'eq.dfdt'};
            {'eq.x0'};
            {'eq.dx0dp'};
            {'M'}
            ];

for i=1:1:length(wfields)
    datain = eval(sprintf('symdynopt_param.%s',cmds{i}));
    fprintf(fid,'case %d %%%s',i-1,wfields{i});fprintf(fid,'\n');
    fprintf(fid,'sys = ');fprintf(fid,makeString(datain));fprintf(fid,';\n');
end

%closing file
fprintf(fid,'end\n');
out = fclose(fid);


%making objfun file
function out = do_objfunfile(symdynopt_param)
%creating file
filename = 'objfun.m';
fid = fopen(filename,'W');

%writting into file
%header of m-file
fprintf(fid,'function [f,Df] = objfun(t,x,u,p,xm)\n');

items = [
            {'f'};
            {'Df.t'};
            {'Df.x'};
            {'Df.u'};
            {'Df.p'}
            ];
cmds = [    
            {'objfun'};
            {'dofdt'};
            {'dofdx'};
            {'dofdu'};
            {'dofdp'};
            ];

for i=1:1:length(items)
    datain = eval(sprintf('symdynopt_param.eq.%s',cmds{i}));
    fprintf(fid,'%s = ',items{i});fprintf(fid,makeString(datain));fprintf(fid,';\n');
end

%closing file
out = fclose(fid);


function out = do_confunfile(symdynopt_param)
%creating file
filename = 'confun.m';
fid = fopen(filename,'W');

%writting into file
%header of m-file
fprintf(fid,'function [c,ceq,Dc,Dceq] = confun(t,x,flag,u,p)\n');
fprintf(fid,'switch flag\n');

items = [
        {'c'};
        {'ceq'};
        {'Dc.t'};
        {'Dc.x'};
        {'Dc.u'};
        {'Dc.p'};
        {'Dceq.t'};
        {'Dceq.x'};
        {'Dceq.u'};
        {'Dceq.p'};
        ];
cmds = [
        {'confun.c.xxx'};
        {'confun.ceq.xxx'};
        {'dcxxxdt'};
        {'dcxxxdx'};
        {'dcxxxdu'};
        {'dcxxxdp'};
        {'dceqxxxdt'};
        {'dceqxxxdx'};
        {'dceqxxxdu'};
        {'dceqxxxdp'};
        ];
opts = [
        {'t0'};
        {'t0tf'};
        {'tf'};
        ];

for k=1:1:length(opts)
    fprintf(fid,'   case %d\n',k-1);
        for i=1:1:length(items)
            if i==3
                fprintf(fid,'       if nargout == 4\n');
            end
            datain = eval(sprintf('symdynopt_param.eq.%s',strrep(cmds{i},'xxx',opts{k})));
            fprintf(fid,'           %s = ',items{i});fprintf(fid,makeString(datain));fprintf(fid,';\n');
            if i==length(items)
                fprintf(fid,'       end\n');
            end
        end
end

%closing file
fprintf(fid,'end\n');
out = fclose(fid);