function sys = process(t,x,flag,u,p)


switch flag,
    case 0 % right sides of ODE/DAEs
        sys = [x(2);
               -x(3)*u+16*t-8;
               u;
               x(1)^2+x(2)^2+0.0005*(x(2)+16*t-8-0.1*x(3)*u^2)^2];
    case 1 % gradients of f with respect to x
        sys = [0 0 0 2*x(1);
               1 0 0 (2*x(2)+2*0.0005*(x(2)+16*t-8-0.1*x(3)*u^2));
               0 -u 0 2*0.0005*(x(2)+16*t-8-0.1*x(3)*u^2)*(-0.1*u^2);
               0 0 0 0];
    case 2 % gradients of f with respect to u
        sys = [0 -x(3) 1 (2*0.0005*(x(2)+16*t-8-0.1*x(3)*u^2)*(-2*0.1*x(3)*u))];
    case 3 % gradients of f with respect to p
        sys = [];
    case 4 % gradients of f with respect to t
        sys = [0 16 0 2*0.0005*(x(2)+16*t-8-0.1*x(3)*u^2)*16];
    case 5 % x0
        sys = [0;-1;-sqrt(5);0];
    case 6 % gradients of x0 with respect to p
        sys = [];
    case 7 % mass matrix M
        sys = [];
    case 8 % unused flag, don't use it !!!
        sys = [];
    otherwise
        error(['unhandled flag = ',num2str(flag)]); 
end