clear all
clc


%*************************************************************************%
%   DYNOPT INPUTS - optimization parameters
%*************************************************************************%
options = optimset('LargeScale','off','Display','iter');
options = optimset(options,'GradObj','on','GradConstr','on');
%options = optimset(options,'DerivativeCheck','on');
options = optimset(options,'MaxFunEvals',1e5);
options = optimset(options,'MaxIter',1e5);
options = optimset(options,'TolFun',1e-5);
options = optimset(options,'TolCon',1e-5);
options = optimset(options,'TolX',1e-5);

symdynoptparam.optimparam.optvar = 3; 
symdynoptparam.optimparam.objtype = []; 
symdynoptparam.optimparam.ncolx = 3; 
symdynoptparam.optimparam.ncolu = 2; 
symdynoptparam.optimparam.li = ones(10,1)*(0.2/10); 
symdynoptparam.optimparam.tf = 0.2;
symdynoptparam.optimparam.ui = [ones(1,10)*10;ones(1,10)*3;ones(1,10)*2;ones(1,10)*10];
symdynoptparam.optimparam.par = []; 
symdynoptparam.optimparam.bdu = [0 20;0 6;0 4;0 20]; 
symdynoptparam.optimparam.bdx = []; 
symdynoptparam.optimparam.bdp =[];
symdynoptparam.optimparam.options = options;

symdynoptparam.multistart.it = [];
symdynoptparam.multistart.bdp = [];


%*************************************************************************%
%	symdynoptparam INPUTS - EQUATIONS
%*************************************************************************%
symdynoptparam.eq.shortcuts = [
                         %subst for   =   subst what
                            {'q'},        {'(u(1)+u(2)+u(4))'};
                            ];
symdynoptparam.eq.process = [
                                % equations, each line means dxi/dt
                                {'u(4)-q*x(1)-17.6*x(1)*x(2)-23.0*x(1)*x(6)*u(3)'}
                                {'u(1)-q*x(2)-17.6*x(1)*x(2)-146.0*x(2)*x(3)'}
                                {'u(2)-q*x(3)-73.0*x(2)*x(3)'}
                                {'-q*x(4)+35.20*x(1)*x(2)-51.30*x(4)*x(5)'}
                                {'-q*x(5)+219.0*x(2)*x(3)-51.30*x(4)*x(5)'}
                                {'-q*x(6)+102.60*x(4)*x(5)-23.0*x(1)*x(6)*u(3)'}
                                {'-q*x(7)+46.0*x(1)*x(6)*u(3)'}
                                {'5.80*((q*x(1))-u(4))-3.70*u(1)-4.10*u(2)+q*(23.0*x(4)+11.0*x(5)+28.0*x(6)+35.0*x(7))-5.0*u(3)^2-0.099'}
                             ];
symdynoptparam.eq.x0 = [
                            %initial condition, each row means xi(0)
                            {'0.1883'}
                            {'0.2507'}
                            {'0.0467'}
                            {'0.0899'}
                            {'0.1804'}
                            {'0.1394'}
                            {'0.1046'}
                            {'0'}
                         ];
symdynoptparam.eq.objfun = [
                                % just one objective function
                                {'-x(8)'}
                             ];
symdynoptparam.eq.confun.ceq.t0 = [
                                        ];
symdynoptparam.eq.confun.c.t0 = [
                                        ];
symdynoptparam.eq.confun.ceq.t0tf = [
                                        ];
symdynoptparam.eq.confun.c.t0tf = [
                                        ];
symdynoptparam.eq.confun.ceq.tf = [
                                        ];
symdynoptparam.eq.confun.c.tf = [
                                        ];                         
% necessary to deside if it's ODE or DAE system
symdynoptparam.M = [];
%*************************************************************************%    
[symdynoptparam, symdynoptout] = symdynopt(symdynoptparam)
%*************************************************************************%