format long
clc
clear all
options = optimset('LargeScale','off','Display','iter');
options = optimset(options,'GradObj','on','GradConstr','on');
%options = optimset(options,'DerivativeCheck','on');
options = optimset(options,'MaxFunEvals',1e5);
options = optimset(options,'MaxIter',1e5);
options = optimset(options,'TolFun',1e-13);
options = optimset(options,'TolCon',1e-13);
options = optimset(options,'TolX',1e-13);


load my1.txt -ascii
objtype.tm = my1(:,1)'; 
objtype.xm = my1(:,2)';

symdynoptparam.optimparam.optvar = 4; 
symdynoptparam.optimparam.objtype = objtype; 
symdynoptparam.optimparam.ncolx = 8;
symdynoptparam.optimparam.ncolu = 1; 
symdynoptparam.optimparam.li = [0.125*ones(8,1)];
symdynoptparam.optimparam.tf = [];
symdynoptparam.optimparam.ui = []; 
symdynoptparam.optimparam.par = [23;0.8;0.3]; 
symdynoptparam.optimparam.bdu = [];
symdynoptparam.optimparam.bdx = [];
symdynoptparam.optimparam.bdp =[0 30;0 2;0 0.5];
symdynoptparam.optimparam.options = options;

symdynoptparam.multistart.it = 3;
symdynoptparam.multistart.bdp = [0 30; 0 2; 0 0.5];
symdynoptparam.multistart.bdu = [];

%*************************************************************************%
%input equations
%*************************************************************************%
symdynoptparam.eq.shortcuts = [
                                {'tf'} {'501'}
                                {'tot'} {'0.0209'}                                
                         %subst for   =   subst what
                            ];
                        
symdynoptparam.eq.process = [
                                {'tot*tf*(- p(1)*x(1)*x(2) - p(2)*x(1)*x(3) - p(3)*x(1)*x(4))'}
                                {'tot*tf*(- p(1)*x(1)*x(2))'}
                                {'tot*tf*(p(1)*x(1)*x(2) - p(2)*x(1)*x(3))'}
                                {'tot*tf*(p(2)*x(1)*x(3) - p(3)*x(1)*x(4))'}
                                {'tot*tf*(p(3)*x(1)*x(4))'}
                             ];
symdynoptparam.eq.x0 = [
                            {'1'}
                            {'0.3333'}
                            {'0'}
                            {'0'}
                            {'0'}
                         ];
symdynoptparam.eq.objfun = [
                                {'(x(1)-xm(1))^2'}
                             ];

symdynoptparam.eq.confun.ceq.t0 = [
                                        ];
symdynoptparam.eq.confun.c.t0 = [
                                        ];
symdynoptparam.eq.confun.ceq.t0tf = [
                                        ];
symdynoptparam.eq.confun.c.t0tf = [
                                        ];
symdynoptparam.eq.confun.ceq.tf = [
                                        ];
symdynoptparam.eq.confun.c.tf = [
                                        ];

symdynoptparam.M = [];

tic
%*************************************************************************%
[symdynoptparam, symdynoptout] = symdynopt(symdynoptparam)
%*************************************************************************%
symdynoptout.p
toc